package dev.peerat.parser.java;

import java.util.function.Predicate;

import dev.peerat.parser.TreeStreamable;
import dev.peerat.parser.java.Variable.VariableStreamable;
import dev.peerat.parser.java.operation.AssignOperation;
import dev.peerat.parser.java.operation.BreakOperation;
import dev.peerat.parser.java.operation.CatchOperation;
import dev.peerat.parser.java.operation.ContinueOperation;
import dev.peerat.parser.java.operation.DoOperation;
import dev.peerat.parser.java.operation.ElseOperation;
import dev.peerat.parser.java.operation.FinallyOperation;
import dev.peerat.parser.java.operation.ForOperation;
import dev.peerat.parser.java.operation.ForeachOperation;
import dev.peerat.parser.java.operation.IfOperation;
import dev.peerat.parser.java.operation.MethodCallOperation;
import dev.peerat.parser.java.operation.ReturnOperation;
import dev.peerat.parser.java.operation.SwitchOperation;
import dev.peerat.parser.java.operation.SynchronizedOperation;
import dev.peerat.parser.java.operation.ThrowOperation;
import dev.peerat.parser.java.operation.TryOperation;
import dev.peerat.parser.java.operation.WhileOperation;
import dev.peerat.parser.java.value.ArrayValue;
import dev.peerat.parser.java.value.BiValue;
import dev.peerat.parser.java.value.InnerElementValue;
import dev.peerat.parser.java.value.InstanceValue;
import dev.peerat.parser.java.value.LambdaValue;
import dev.peerat.parser.java.value.MethodCallValue;
import dev.peerat.parser.java.value.ModifierValue;
import dev.peerat.parser.java.value.StaticValue;
import dev.peerat.parser.java.value.TriValue;
import dev.peerat.parser.java.value.Value;
import dev.peerat.parser.java.value.Value.ValueStreamable;

public abstract class Operation extends JavaElement{
	
	public static interface OperationContainer{
		
		void addOperation(Operation operation);
		
	}
	
	public Operation(){}
	
	public OperationStreamable stream(){
		return new OperationStreamable();
	}
	
	public class OperationStreamable implements TreeStreamable{
		
		public OperationStreamable(){}
		
		public OperationStreamable operationFilter(Predicate<Operation> filter){ return null; }
		public OperationStreamable assignOperationFilter(Predicate<AssignOperation> filter){ return null; }
		public OperationStreamable breakOperationFilter(Predicate<BreakOperation> filter){ return null; }
		public OperationStreamable catchOperationFilter(Predicate<CatchOperation> filter){ return null; }
		public OperationStreamable continueOperationFilter(Predicate<ContinueOperation> filter){ return null; }
		public OperationStreamable doOperationFilter(Predicate<DoOperation> filter){ return null; }
		public OperationStreamable elseOperationFilter(Predicate<ElseOperation> filter){ return null; }
		public OperationStreamable finallyOperationFilter(Predicate<FinallyOperation> filter){ return null; }
		public OperationStreamable foreachOperationFilter(Predicate<ForeachOperation> filter){ return null; }
		public OperationStreamable forOperationFilter(Predicate<ForOperation> filter){ return null; }
		public OperationStreamable ifOperationFilter(Predicate<IfOperation> filter){ return null; }
		public OperationStreamable methodCallOperationFilter(Predicate<MethodCallOperation> filter){ return null; }
		public OperationStreamable returnOperationFilter(Predicate<ReturnOperation> filter){ return null; }
		public OperationStreamable switchOperationFilter(Predicate<SwitchOperation> filter){ return null; }
		public OperationStreamable synchronizedOperationFilter(Predicate<SynchronizedOperation> filter){ return null; }
		public OperationStreamable throwOperationFilter(Predicate<ThrowOperation> filter){ return null; }
		public OperationStreamable tryOperationFilter(Predicate<TryOperation> filter){ return null; }
		public OperationStreamable whileOperationFilter(Predicate<WhileOperation> filter){ return null; }
		
		public ValueStreamable valueFilter(Predicate<Value> filter){ return null; }
		public ValueStreamable arrayValueFilter(Predicate<ArrayValue> filter){ return null; }
		public ValueStreamable biValueFilter(Predicate<BiValue> filter){ return null; }
		public ValueStreamable innerElementValueFilter(Predicate<InnerElementValue> filter){ return null; }
		public ValueStreamable instanceValueFilter(Predicate<InstanceValue> filter){ return null; }
		public ValueStreamable lambdaValueFilter(Predicate<LambdaValue> filter){ return null; }
		public ValueStreamable methodCallValueFilter(Predicate<MethodCallValue> filter){ return null; }
		public ValueStreamable modifierValueFilter(Predicate<ModifierValue> filter){ return null; }
		public ValueStreamable staticVFilter(Predicate<StaticValue> filter){ return null; }
		public ValueStreamable triValueFilter(Predicate<TriValue> filter){ return null; }
		
		public VariableStreamable variableFilter(Predicate<Variable> filter){ return null; }
		
	}

}
